## GUPnPControlPoint GUPnPControlPoint — Class for resource discovery. |

## Functions

GUPnPControlPoint * | gupnp_control_point_new ()
GUPnPControlPoint * | gupnp_control_point_new_full ()
GUPnPResourceFactory * | gupnp_control_point_get_resource_factory ()
const GList * | gupnp_control_point_list_device_proxies ()
const GList * | gupnp_control_point_list_service_proxies ()

## Types and Values

| GUPnPControlPoint

## Description

GUPnPControlPoint handles device and service discovery. After creating a control point and activating it using `gssdp_resource_browser_set_active()`, the ::device-proxy-available, ::service-proxy-available, ::device-proxy-unavailable and ::service-proxy-unavailable signals will be emitted whenever the availability of a device or service matching the specified discovery target changes.

## Functions

### gupnp_control_point_new ()

    GUPnPControlPoint *
    gupnp_control_point_new (GUPnPContext *context,
                             const char *target);

Create a new GUPnPControlPoint with the specified `context` and `target` .

`target` should be a service or device name, such as `urn:schemas-upnp-org:service:WANIPConnection:1` or `urn:schemas-upnp-org:device:MediaRenderer:1`.

#### Parameters

context | A GUPnPContext |
target | The search target |

#### Returns

A new GUPnPControlPoint object.

### gupnp_control_point_new_full ()

    GUPnPControlPoint *
    gupnp_control_point_new_full (GUPnPContext *context,
                                  GUPnPResourceFactory *factory,
                                  const char *target);

Create a new GUPnPControlPoint with the specified `context` , `factory` and `target` .

`target` should be a service or device name, such as `urn:schemas-upnp-org:service:WANIPConnection:1` or `urn:schemas-upnp-org:device:MediaRenderer:1`.

#### Parameters

context | A GUPnPContext |
factory | A GUPnPResourceFactory |
target | The search target |

#### Returns

A new GUPnPControlPoint object.

### gupnp_control_point_get_resource_factory ()

    GUPnPResourceFactory *
    gupnp_control_point_get_resource_factory
                                   (GUPnPControlPoint *control_point);

Get the GUPnPResourceFactory used by the `control_point` .

#### Parameters

control_point | A GUPnPControlPoint |

#### Returns

A GUPnPResourceFactory.

[transfer none]

### gupnp_control_point_list_device_proxies ()

    const GList *
    gupnp_control_point_list_device_proxies
                                   (GUPnPControlPoint *control_point);

`gupnp_control_point_list_device_proxies` is deprecated and should not be used in newly-written code.

Get the GList of discovered GUPnPDeviceProxy objects. Do not free the list nor its elements.

#### Parameters

control_point | A GUPnPControlPoint |

#### Returns

a GList of GUPnPDeviceProxy objects.

[element-type GUPnP.DeviceProxy][transfer none]

### gupnp_control_point_list_service_proxies ()

    const GList *
    gupnp_control_point_list_service_proxies
                                   (GUPnPControlPoint *control_point);

Get the GList of discovered GUPnPServiceProxy objects. Do not free the list nor its elements.

#### Parameters

control_point | A GUPnPControlPoint |

#### Returns

a GList of GUPnPServiceProxy objects.

[element-type GUPnP.ServiceProxy][transfer none]

## Types and Values

### GUPnPControlPoint

    typedef struct _GUPnPControlPoint GUPnPControlPoint;